Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Static Public Member Functions

# MaterialPool Class Reference

The MaterialPool (there is only one in the universe) serves to unify different pointers to the same Material, so we do not (a) waste memory with many different Material objects that are all equivalent, and (b) waste time switching the graphics engine between different Material states that are really the same thing. More...

List of all members.

## Static Public Member Functions
static int | garbageCollect ()
| Releases only those materials in the pool that have a reference count of exactly 1; i.e.
static Material | getMaterial (Material temp)
| Returns a Material pointer that represents the same material described by temp, except that it is a shared pointer.
static | listContents (ostream out)
| Lists the contents of the material pool to the indicated output stream.
static | releaseAllMaterials ()
| Releases all materials in the pool and restores the pool to the empty state.
static | releaseMaterial (Material temp)
| Removes the indicated material from the pool.
static | write (ostream out)
| Lists the contents of the material pool to the indicated output stream.

## Detailed Description

The MaterialPool (there is only one in the universe) serves to unify different pointers to the same Material, so we do not (a) waste memory with many different Material objects that are all equivalent, and (b) waste time switching the graphics engine between different Material states that are really the same thing.

The idea is to create a temporary Material representing the lighting state you want to apply, then call get_material(), passing in your temporary Material. The return value will either be a new Material object, or it may be the the same object you supplied; in either case, it will have the same value.

## Member Function Documentation

static int garbageCollect | ( |  | ) | `[static]`

Releases only those materials in the pool that have a reference count of exactly 1; i.e.

only those materials that are not being used outside of the pool. Returns the number of materials released.

static Material getMaterial | ( | Material | temp | ) | `[static]`

Returns a Material pointer that represents the same material described by temp, except that it is a shared pointer.

Each call to get_material() passing an equivalent Material pointer will return the same shared pointer.

If you modify the shared pointer, it will automatically disassociate it from the pool.

Also, the return value may be a different pointer than that passed in, or it may be the same pointer. In either case, the passed in pointer has now been sacrificed to the greater good and should not be used again (like any other PointerTo, it will be freed when the last reference count is removed).

static listContents | ( | ostream | out | ) | `[static]`

Lists the contents of the material pool to the indicated output stream.

static releaseAllMaterials | ( |  | ) | `[static]`

Releases all materials in the pool and restores the pool to the empty state.

static releaseMaterial | ( | Material | temp | ) | `[static]`

Removes the indicated material from the pool.

static write | ( | ostream | out | ) | `[static]`

Lists the contents of the material pool to the indicated output stream.

All Classes Namespaces Functions Variables Enumerations Enumerator Properties